neovim-config/install.sh

75 lines
2.3 KiB
Bash
Raw Normal View History

#!/bin/sh
2021-03-19 01:42:44 +00:00
# check if git command is installed
command -v git > /dev/null || {
printf "Install git before proceeding\n"
exit 1
2021-03-19 01:42:44 +00:00
}
printf "%s\n" "Installing packer"
2021-03-28 17:50:53 +00:00
if [ -d ~/.local/share/nvim/site/pack/packer ]; then
printf "%s\n" "Clearning previous packer installs"
rm -rf ~/.local/share/nvim/site/pack
2021-03-28 17:50:53 +00:00
fi
printf "\n%s\n" "=> Cloning packer.."
if git clone https://github.com/wbthomason/packer.nvim \
~/.local/share/nvim/site/pack/packer/start/packer.nvim; then
printf "%s\n" "=> Packer installed!"
else
printf "Error: Couldn't clone packer\n"
exit 1
fi
printf "%s\n" "Linking config"
printf "%s\n" "Old nvim config will be changed to nvim.bak if exists! :0"
2021-03-27 02:50:15 +00:00
2021-04-08 01:59:39 +00:00
# copying config
if [ -d ~/.config/nvim ]; then
printf "%s\n" "Nvim Directory exists"
printf "%s\n" "Changing nvim to nvim.bak"
mv ~/.config/nvim/ ~/.config/nvim.bak/
printf "%s\n" "Creating new nvim directory"
mkdir -p ~/.config/nvim
else
printf "%s\n" "Nvim Config doesn't exist so creating one"
mkdir -p ~/.config/nvim/
fi
2021-03-27 02:50:15 +00:00
{ cp -r init.lua ~/.config/nvim/ && cp -r lua ~/.config/nvim/ ;} || {
printf "Error: Couldn't copy nvim config\n"
exit 1
}
2021-03-27 02:50:15 +00:00
# change shell in nvim config
_CURRENT_SHELL="${SHELL##*/}"
printf "%s\n: " "Which shell do you want to use ? [ Enter nothing for current shell ( $_CURRENT_SHELL ) ]"
read -r shellname
shellname="${shellname:-${_CURRENT_SHELL}}"
printf "%s\n" "$shellname"
2021-04-06 04:05:22 +00:00
# don't try to do any changes if given shellname is same as bash
if ! [ bash = "$shellname" ]; then
# Reference: https://stackoverflow.com/a/4247319
if "$(command -v sed)" -i'.bak' -e "s/bash/$shellname/g" ~/.config/nvim/lua/mappings.lua; then
printf "\n%s\n" "=> Shell changed to $shellname on nvim successfully!"
else
printf "\n%s\n" "Cannot edit with sed, edit ~/.config/nvim/lua/mappings.lua manually to replace bash with $shellname."
fi
rm -f ~/.config/nvim/lua/mappings.lua.bak # delete backup file created by sed
2021-04-24 12:51:13 +00:00
else
printf "\n%s\n" "=> Shell changed to $shellname on nvim successfully!"
2021-04-24 12:51:13 +00:00
fi
printf "\n%s\n" "=> Neovim will open with some errors, just press enter" && sleep 1
2021-03-19 01:42:44 +00:00
2021-06-26 02:05:33 +00:00
# install all plugins + compile them
if _NVIM="$(command -v nvim)"; then
"${_NVIM}" +PackerSync
else
printf "Error: Neovim is not installed, install Neovim >= 5.x and then run the below command\n"
printf " nvim +PackerSync\n"
exit 1
fi